SystemOrganization addCategory: #'Glamour-Scripting'!

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol 
	 
	^self addColumn: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 10/22/2009 13:27'!
column: aBlockOrSymbol size: anInteger 
	 
	^self addColumn: aBlockOrSymbol size: anInteger! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol span: anInteger 
	 
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol 
	 
	^self addRow: aBlockOrSymbol! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 10/22/2009 13:26'!
row: aBlockOrSymbol size: anInteger 
	 
	^self addRow: aBlockOrSymbol size: anInteger! !

!GLMTableLayoutBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol span: anInteger 
	 
	^self addRow: aBlockOrSymbol span: anInteger! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 10/5/2009 00:36'!
beMultiple
	allowsMultipleSelection := true! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 10/5/2009 00:37'!
beSingle
	allowsMultipleSelection := false! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/22/2009 08:36'!
filterOn: aBlock 
	filterBlock := aBlock! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/22/2009 08:40'!
searchOn: aBlock
	searchBlock := aBlock! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/30/2009 01:28'!
showOnly: aBlock
	amountToShowBlock := aBlock! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/13/2009 04:14'!
tags: anObject
	tagsBlock := anObject! !

Object subclass: #Glamorous
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Scripting'!

!Glamorous commentStamp: 'tg 9/20/2009 13:59' prior: 0!
A Glamorous is just a library of browsers stored as methods on the class side.!

!Glamorous classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/11/2009 19:19'!
editor
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser row: #browser; row: #source.
	browser title: 'Glamorous Editor'.
	browser showOn: #source; using: [
		browser text
			forSmalltalk;
			update: #selection on: $o entitled: 'Open (o)' with: [:text | text text]].
	browser showOn: #browser; from: #source; using: [
		browser dynamic
			display: [:source | 
				(Compiler evaluate: source logged: false)]].
	browser openOn: '| browser |
	'! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	"this message sets a custom presentation to the current Transmission. 
	it is to be used within the using: block. 
	this message is particularly useful when you want to set a browser as a presentation" 
	 
	scriptTransmission addPresentation: aPresentation. 
	^aPresentation! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
from: anOriginPortReference 
	"send this message after showOn: to specify an origin for the Transmission. 
	you can cascade several from: to specify additional origins" 
	 
	scriptTransmission 
		addActiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
passivelyFrom: anOriginPortReference 
	"passivelyForm: is similar to from: only the origin will be a passive one. 
	in other words, a change in the origin port will not initiate a Transmission" 
	 
	scriptTransmission 
		addPassiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
sendTo: aDesinationPortReference from: anOriginPortReference 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMSimpleTransmission new) 
				origin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 9/18/2009 11:38'!
sendTo: aDesinationPortReference from: anOriginPortReference with: aBlock 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMSimpleTransformingTransmission new) 
				origin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				transformation: aBlock; 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
sendTo: aDesinationPortReference fromOutside: anOriginPortName 
	"this is a shortcut method for propagating inside an outer port name to an inner port reference" 
	 
	self 
		sendTo: aDesinationPortReference 
		from: #outer -> anOriginPortName! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
sendToOutside: aPortName from: anOriginPortReference 
	"this is a shortcut method for exposing an inner port reference as an outer port name" 
	 
	self 
		sendTo: #outer -> aPortName 
		from: anOriginPortReference! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
showOn: aDestinationPane 
	"send this message when at the beginning of specifying a Transmission" 
	 
	scriptTransmission := (GLMBundleTransmission new) 
		destination: (self resolveDestinationPort: aDestinationPane); 
		yourself! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
using: aBlock 
	"this message should be sent after showOn: and a sequence of from: messages. 
	the using: message takes a block as a parameter to specify the presentations that accompany the Transmission" 
	 
	aBlock value. 
	scriptTransmission origins isEmpty 
		ifTrue: [self addJumpstart: scriptTransmission] 
		ifFalse: [self addTransmission: scriptTransmission]. 
	scriptTransmission := nil! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol 
	 
	^self addRow: aBlockOrSymbol! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: 'tg 10/21/2009 22:08'!
row: aBlockOrSymbol size: anInteger 
	 
	^self addRow: aBlockOrSymbol size: anInteger! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol span: anInteger 
	 
	^self addRow: aBlockOrSymbol span: anInteger! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 6/2/2009 23:39'!
context

	context isNil ifTrue: [context := OrderedCollection new].
	^context! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	 
	scriptTransmission isNil 
		ifTrue: [self addPresentation: aPresentation] 
		ifFalse: [self scriptTransmission addPresentation: aPresentation]. 
	^aPresentation! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
fromPrevious: aPortSymbol 
	 
	self scriptTransmission addActiveOrigin: (GLMPort new name: aPortSymbol)! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 6/2/2009 23:40'!
initializeContextWith: aPane

	context := OrderedCollection with: aPane! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
passivelyFromPrevious: aPortSymbol 
	 
	self scriptTransmission addPassiveOrigin: (GLMPort new name: aPortSymbol)! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
scriptTransmission 
	 
	^scriptTransmission 
		ifNil: [scriptTransmission := GLMBundleTransmission new]! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 6/2/2009 23:41'!
updateContextWith: aPane 
	context isNil ifTrue: [context := OrderedCollection new].
	context add: aPane! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
using: aBlock 
	 
	aBlock value. 
	self addTransmission: scriptTransmission. 
	scriptTransmission := nil! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 6/2/2009 17:11'!
context

	^OrderedCollection new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	 
	self subclassResponsibility! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
defaultRenderer 
	 
	^GLMRenderer subclasses first new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 10/22/2009 22:11'!
diff
	 
	^self custom: GLMDiffPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 9/11/2009 15:33'!
dynamic
	^ self custom: GLMDynamicPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: 'jorge.ressia 6/2/2009 17:10'!
initializeContextWith: aPane! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
list 
	 
	^self custom: GLMListPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 5/6/2009 13:16'!
magritte
	^ self custom: GLMMagrittePresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
mondrian 
	 
	^self custom: GLMMondrianPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
open 
	 
	^self openWith: self defaultRenderer! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
openOn: anObject 
	 
	^self 
		openOn: anObject 
		with: self defaultRenderer! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
openOn: anObject with: aRenderer 
	 
	self startOn: anObject. 
	^aRenderer open: self! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
openWith: aRenderer 
	 
	^self openOn: nil with: aRenderer! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
startOn: anObject 
	 
	self initializeScriptingDefaults. 
	self entity: anObject! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
text 
	 
	^self custom: GLMTextPresentation new! !

!GLMBrowser methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
tree 
	 
	^self custom: GLMTreePresentation new! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol 
	 
	^self addColumn: aBlockOrSymbol! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: 'tg 10/21/2009 22:08'!
column: aBlockOrSymbol size: anInteger 
	 
	^self addColumn: aBlockOrSymbol size: anInteger! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol span: anInteger 
	 
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
act: aBlock entitled: aString 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/8/2009 13:33'!
act: aBlock entitled: aString categorized: anotherString
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/28/2009 14:53'!
act: aBlock icon: anIcon entitled: aString
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
act: aBlock on: aCharacter 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
act: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/8/2009 13:33'!
act: aBlock on: aCharacter entitled: aString categorized: anotherString 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 8/4/2009 15:12'!
actions: aBlock 
	dynamicActionsBlock := aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
display: aBlock 
	 
	self transformation: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 25/2/09 23:39'!
on: aCharacter do: aBlock
	
	self
		addAction:
			((GLMAction new)
				action: aBlock;
				shortcut: aCharacter;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 8/25/2009 16:01'!
send: aBlock 
	self selectionTransformation: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/8/2009 13:34'!
update: aPortSymbol on: aCharacter entitled: aString categorized: anotherString with: aBlock 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				title: aString;
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 8/4/2009 15:08'!
update: aPortSymbol on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 8/4/2009 15:20'!
update: aPortSymbol on: aCharacter with: aBlock
	self addAction: 
			((GLMAction new) 
				action: ((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
when: aBlock 
	 
	self condition: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
whenKindOf: aClass 
	 
	self when: [:each | each isKindOf: aClass]! !
